<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( class_exists( 'WC_Payment_Gateway' ) ) {
    class WC_Cashapp_Gateway extends WC_Payment_Gateway
    {
        protected  $EmailReceiptsKey ;
        // protected $CashAppForwardingEmail;
        // protected $CashAppForwardingFormat;
        public function __construct()
        {
            $this->id = 'cashapp';
            // payment gateway plugin ID
            $this->icon = WCCASHAPP_PLUGIN_DIR_URL . 'assets/images/cashapp_35.png';
            // URL of the icon that will be displayed on checkout page near your gateway name
            $this->has_fields = true;
            // in case you need a custom form
            $this->method_title = 'Cash App';
            $this->method_description = '<p>Easily receive Cash App payments.</p>
			<p>If you are a Square merchant, <strong>enable <a href="' . esc_url( admin_url( 'admin.php?page=wc-settings&tab=checkout&section=cash-app-pay' ) ) . '">Cash App Pay</a> instead</p>
			<p>See how the <a href="' . admin_url( 'admin.php?page=wc_cashapp_compared' ) . '">Cash App Pay payment method compares to Cash App payment method</a></p>';
            // will be displayed on the options page
            $this->init_settings();
            $this->enabled = $this->get_option( 'enabled' );
            $this->title = ( $this->get_option( 'checkout_title' ) ? $this->get_option( 'checkout_title' ) : $this->method_title );
            $this->ReceiverCASHAPPNo = $this->get_option( 'ReceiverCASHAPPNo' );
            $this->ReceiverCASHAPPNoOwner = $this->get_option( 'ReceiverCASHAPPNoOwner' );
            $this->ReceiverCashApp = $this->get_option( 'ReceiverCashApp' );
            $this->ReceiverCashAppOwner = $this->get_option( 'ReceiverCashAppOwner' );
            $this->ReceiverCASHAPPEmail = $this->get_option( 'ReceiverCASHAPPEmail' );
            $this->CashAppForwardingURL = wp_kses_post( get_bloginfo( 'url' ) . '/wp-json/wc-cashapp/v1/update-cashapp-order' );
            $this->update_option( 'CashAppForwardingURL', $this->CashAppForwardingURL );
            // $this->EmailReceiptsKey = $this->get_option( 'EmailReceiptsKey' );
            $this->CashAppForwardingURLClmln = wp_kses_post( get_bloginfo( 'url' ) . '/wp-json/wc-cashapp/v1/cloudmailin/update-cashapp-order' );
            $this->update_option( 'CashAppForwardingURLClmln', $this->CashAppForwardingURLClmln );
            // $this->CashAppForwardingEmail = $this->get_option( 'CashAppForwardingEmail' );
            // $this->CashAppForwardingFormat = wp_kses_post( 'JSON - Normalized (recommended)' );
            // $this->update_option( 'CashAppForwardingFormat', $this->CashAppForwardingFormat );
            $this->CashAppStockManagement = $this->get_option( 'CashAppStockManagement' );
            $this->checkout_description = $this->get_option( 'checkout_description' );
            $this->cashapp_notice = $this->get_option( 'cashapp_notice' );
            $this->store_instructions = $this->get_option( 'store_instructions' );
            $this->display_cashapp = $this->get_option( 'display_cashapp' );
            $this->display_cashapp_logo_button = $this->get_option( 'display_cashapp_logo_button' );
            $this->fullWidthColumn = $this->get_option( 'fullWidthColumn' );
            $this->toggleSupport = $this->get_option( 'toggleSupport' );
            $this->toggleTutorial = $this->get_option( 'toggleTutorial' );
            $this->toggleCredits = $this->get_option( 'toggleCredits' );
            // hold stock admin_url('admin.php?page=wc-settings&tab=products&section=inventory)
            
            if ( isset( $this->ReceiverCashApp ) ) {
                $test = ' <a href="https://cash.app/' . esc_attr( wp_kses_post( $this->ReceiverCashApp ) ) . '/1" target="_blank">Test</a>';
            } else {
                $test = '';
            }
            
            $new = ' <sup style="color:#0c0">NEW</sup>';
            $newFeature = " <sup style='color:#c00;'>NEW FEATURE</sup>";
            $improvedFeature = " <sup style='color:#0c0;'>IMPROVED FEATURE</sup>";
            $comingSoon = " <sup style='color:#00c;'>COMING SOON</sup>";
            $emrcpts = ' <a href="' . esc_attr( wp_kses_post( admin_url( 'admin.php?page=wc_cashapp_automated_status' ) ) ) . '" target="_blank">CONNECT</a>';
            $cloudmailin = ' <a href="' . esc_attr( wp_kses_post( admin_url( 'admin.php?page=wc_cashapp_cloudmailin' ) ) ) . '" target="_blank">CONNECT</a>';
            global  $cashapp_fs ;
            $upgrade_url = cashapp_fs()->get_upgrade_url();
            $pro = ' <a style="text-decoration:none" href="' . $upgrade_url . '" target="_blank"><sup style="color:red">PRO</sup></a>';
            $edit_with_pro = ' <a style="text-decoration:none" href="' . $upgrade_url . '" target="_blank">APPLY CHANGES WITH PRO</a>';
            $this->form_fields = array(
                'enabled'                     => array(
                'title'   => 'Enable CASHAPP' . $test,
                'label'   => 'Check to Enable / Uncheck to Disable',
                'type'    => 'checkbox',
                'default' => 'no',
            ),
                'checkout_title'              => array(
                'title'       => 'Checkout Title',
                'type'        => 'text',
                'description' => 'This is the title which the user sees on the checkout page.',
                'default'     => $this->title,
                'placeholder' => $this->title,
            ),
                'ReceiverCASHAPPNo'           => array(
                'title'       => 'Receiver Cash App No',
                'type'        => 'text',
                'description' => 'This is the phone number associated with your store Cash App account or your receiving Cash App account. Customers will send money to this number',
                'placeholder' => "+1234567890",
            ),
                'ReceiverCashApp'             => array(
                'title'       => 'Receiver Cash App account' . $test,
                'type'        => 'text',
                'description' => 'This is the Cash App account associated with your store Cash App account. Customers will send money to this Cash App account',
                'default'     => '$',
                'placeholder' => '$cashId',
            ),
                'ReceiverCashAppOwner'        => array(
                'title'       => "Receiver Cash App Owner's Name",
                'type'        => 'text',
                'description' => 'This is the name associated with your store Cash App account. Customers will send money to this Cash App account name',
                'placeholder' => 'Jane D',
            ),
                'ReceiverCASHAPPEmail'        => array(
                'title'       => "Receiver Cash App Owner's Email",
                'type'        => 'text',
                'description' => 'This is the email associated with your store Cash App account or your receiving Cash App account. Customers will send money to this email',
                'default'     => "@gmail.com",
                'placeholder' => "email@website.com",
            ),
                'CashAppForwardingURL'        => array(
                'title'       => 'Connect your Email Receipts via emailreceipts.io' . $emrcpts,
                'type'        => 'text',
                'description' => 'This is the URL that will be imported to emailreceipts.io while setting up' . $emrcpts,
                'default'     => $this->CashAppForwardingURL,
                'placeholder' => $this->CashAppForwardingURL,
                'css'         => 'width:80%; pointer-events: none;',
                'class'       => 'disabled',
            ),
                'CashAppStockManagement'      => array(
                'title'       => 'Reduce Stock ONLY after payment receipt' . $pro,
                'label'       => 'Check to to reduce stock when order goes to processing / Uncheck to reduce stock when order goes on-hold' . $edit_with_pro,
                'type'        => 'checkbox',
                'description' => 'If you want to reduce stock once payment is received, check this box',
                'default'     => 'no',
                'css'         => 'pointer-events: none;',
                'class'       => 'disabled',
            ),
                'checkout_description'        => array(
                'title'       => 'Checkout Page Notice' . $pro,
                'type'        => 'textarea',
                'description' => 'This is the description which the user sees during checkout.' . $edit_with_pro,
                'default'     => 'Send money to $cashtag or click the Cash App button below',
                'css'         => 'width:80%; pointer-events: none;',
                'class'       => 'disabled',
            ),
                'cashapp_notice'              => array(
                'title'       => 'Thank You Notice' . $pro,
                'type'        => 'textarea',
                'description' => 'Notice that will be added to the thank you page before store instructions if any.' . $edit_with_pro,
                'default'     => "<p>We are checking our systems to confirm that we received. If you haven't sent the money already, please make sure to do so now.</p>" . '<p>Once confirmed, we will proceed with the shipping and delivery options you chose.</p>' . '<p>Thank you for doing business with us! You will be updated regarding your order details soon.</p>',
                'css'         => 'width:80%; pointer-events: none;',
                'class'       => 'disabled',
            ),
                'store_instructions'          => array(
                'title'       => 'Store Instructions' . $pro,
                'type'        => 'textarea',
                'description' => 'Store Instructions that will be added to the thank you page and emails.' . $edit_with_pro,
                'default'     => "Please send the total amount requested to our store if you haven't yet",
                'css'         => 'width:80%; pointer-events: none;',
                'class'       => 'disabled',
            ),
                'display_cashapp'             => array(
                'title'       => 'Customers place order first before getting Cash App info' . $pro,
                'label'       => 'Uncheck to remove Cash App info before placing order / Check to show Cash App info first',
                'type'        => 'checkbox',
                'description' => 'Disable to remove BOTH the Cash App image and QR code from your payment method on checkout. It will still be displayed on the thank you page, email notifications, and customer notes' . $edit_with_pro,
                'default'     => 'yes',
                'class'       => 'disabled',
            ),
                'display_cashapp_logo_button' => array(
                'title'       => 'Show ONLY the QR code in the payment method on checkout' . $pro,
                'label'       => 'Check to show the Cash App logo button / Uncheck to remove the Cash App logo button',
                'type'        => 'checkbox',
                'description' => 'Disable to remove the big Cash App image button in the payment method on checkout' . $edit_with_pro,
                'default'     => 'no',
                'class'       => 'disabled',
            ),
                'fullWidthColumn'             => array(
                'title'       => 'Enable Full Width Columns on checkout' . $pro,
                'label'       => 'Check to Enable / Uncheck to Disable',
                'type'        => 'checkbox',
                'description' => 'When checked, the amount, reference number and QR code button will occupy the full width of their container. Only recommended when payment box is half the screen width' . $edit_with_pro,
                'default'     => 'no',
                'class'       => 'disabled',
            ),
                'toggleSupport'               => array(
                'title'       => 'Enable Support message' . $pro,
                'label'       => 'Check to Enable / Uncheck to Disable',
                'type'        => 'checkbox',
                'description' => 'Help your customers checkout with ease by letting them know how to contact you' . $edit_with_pro,
                'default'     => 'yes',
                'class'       => 'disabled',
            ),
                'toggleTutorial'              => array(
                'title'       => 'Enable Tutorial to display 1min video link',
                'label'       => 'Check to Enable / Uncheck to Disable',
                'type'        => 'checkbox',
                'description' => 'Help your customers checkout with ease by showing this tutorial link',
                'default'     => 'no',
            ),
                'toggleCredits'               => array(
                'title'       => 'Enable Credits to display Powered by The African Boss',
                'label'       => 'Check to Enable / Uncheck to Disable',
                'type'        => 'checkbox',
                'description' => 'Help us spread the word about this plugin by sharing that we made this plugin',
                'default'     => 'no',
            ),
            );
            // Gateways can support subscriptions, refunds, saved payment methods
            $this->supports = array( 'products' );
            // This action hook saves the settings
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            // We need custom JavaScript to obtain a token
            add_action( 'wp_enqueue_scripts', array( $this, 'payment_scripts' ) );
            // Thank you page
            add_action( 'woocommerce_thankyou_cashapp', array( $this, 'thankyou_page' ) );
            // Customer Emails
            add_action(
                'woocommerce_email_order_details',
                array( $this, 'email_instructions' ),
                10,
                3
            );
        }
        
        public function connect_emailreceipts()
        {
            return wp_kses_post( '
			<div class="container">
				<form id="store-connect-form" name="store-connect-form" data-name="Store Connect Form" action="https://emailreceipts.io/store/connect"
					method="POST" target="_blank" class="main-content">

					<input type="hidden" name="fname" data-name="First Name" placeholder="First Name"
						id="fname" value="' . get_user_meta( $current_user->ID, 'first_name', true ) . '" required />

					<input type="hidden" name="lname" data-name="Last Name" placeholder="Last Name"
						id="lname" value="' . get_user_meta( $current_user->ID, 'last_name', true ) . '" required />

					<input type="hidden" name="email" data-name="Email" placeholder="Email"
					id="email" value="' . get_bloginfo( "admin_email" ) . '" required />

					<input type="hidden" name="phone" data-name="Phone Number" placeholder="Phone Number"
						id="phone" value="' . get_user_meta( $current_user->ID, 'billing_phone', true ) . '" required />

					<input type="hidden" name="name" data-name="Store Name"
						placeholder="Store Name" id="name" value="' . get_bloginfo( "name" ) . '" required />

					<input type="hidden" name="domain" data-name="Store Domain"
						placeholder="Store Domain" id="domain" value="' . get_site_url() . '" required />

					<input type="hidden" name="institution" data-name="Financial Institution"
						placeholder="Financial Institution" id="institution" value="Cash App" required />

					<input type="hidden" name="accountid" data-name="Financial Account ID"
						placeholder="Financial Account ID" id="accountid" value="' . $this->ReceiverCashApp . '" />

					<input type="hidden" name="accountname" data-name="Financial Account Name"
						placeholder="Financial Account Name" id="accountname" value="' . $this->ReceiverCashAppOwner . '" />

					<input type="hidden" name="accountemail" data-name="Financial Account Email"
						placeholder="Financial Account Email" id="accountemail" value="' . $this->ReceiverCASHAPPEmail . '" required />

					<input type="hidden" name="webhook" data-name="Webhook URL"
						placeholder="Webhook URL" id="webhook" value="' . $this->CashAppForwardingURL . '" required />

					<input type="hidden" name="extension" id="extension" value="' . explode( "/", WCCASHAPP_PLUGIN_BASENAME )[0] . '" />
					<input type="hidden" name="key" id="key" value="' . $this->EmailReceiptsKey . '" />
					' . wp_nonce_field( 'connect_store_to_emailreceipts' ) . '
					<button type="submit" class="button button-primary">CONNECT</button>
				</form>
			</div>' );
        }
        
        //Checkout page
        public function payment_fields()
        {
            require_once WCCASHAPP_PLUGIN_DIR . 'includes/pages/checkout.php';
        }
        
        //Payment Custom JS and CSS
        public function payment_scripts()
        {
            require_once WCCASHAPP_PLUGIN_DIR . 'includes/functions/payment_scripts.php';
        }
        
        //Thank you page
        public function thankyou_page( $order_id )
        {
            global  $woocommerce, $order ;
            $order = wc_get_order( $order_id );
            if ( 'cashapp' === $order->get_payment_method() ) {
                require_once WCCASHAPP_PLUGIN_DIR . 'includes/pages/thankyou.php';
            }
        }
        
        //Add content to the WC emails
        public function email_instructions( $order, $sent_to_admin, $plain_text = false )
        {
            if ( !$sent_to_admin && 'on-hold' === $order->get_status() && 'cashapp' === $order->get_payment_method() ) {
                require_once WCCASHAPP_PLUGIN_DIR . 'includes/notifications/email.php';
            }
        }
        
        // validate cashtag
        public function validate_fields()
        {
            
            if ( isset( $_POST['cashtag'] ) ) {
                $customer_cashtag = sanitize_text_field( trim( $_POST['cashtag'] ) );
                if ( !$customer_cashtag || strlen( $customer_cashtag ) < 3 ) {
                    wc_add_notice( esc_html( __( 'Your cashtag is missing', 'wc-cashapp' ) ), 'error' );
                }
            }
        
        }
        
        //Process Order
        public function process_payment( $order_id )
        {
            global  $woocommerce, $order ;
            $order = wc_get_order( $order_id );
            
            if ( !is_wp_error( $order ) ) {
                
                if ( isset( $_POST['cashtag'] ) ) {
                    $customer_cashtag = sanitize_text_field( trim( $_POST['cashtag'] ) );
                    
                    if ( $customer_cashtag ) {
                        // update_post_meta($order_id, 'customer_cashtag', $customer_cashtag);
                        $order->update_meta_data( 'customer_cashtag', $customer_cashtag );
                        $order->save();
                    }
                
                }
                
                // Mark as on-hold (we're awaiting the payment).
                $order->update_status( apply_filters( 'woocommerce_cashapp_process_payment_order_status', 'on-hold', $order ), __( 'Checking for payment', 'woocommerce' ) );
                if ( 'cashapp' === $order->get_payment_method() ) {
                    require_once WCCASHAPP_PLUGIN_DIR . 'includes/notifications/note.php';
                }
                
                if ( cashapp_fs()->is_plan__premium_only( 'pro' ) && $this->CashAppStockManagement == 'on' && $this->CashAppForwardingEmail ) {
                } else {
                    // reduce inventory
                    $order->reduce_order_stock();
                }
                
                // Empty cart
                $woocommerce->cart->empty_cart();
                // Redirect to the thank you page
                return array(
                    'result'   => 'success',
                    'redirect' => $this->get_return_url( $order ),
                );
            } else {
                wc_add_notice( 'Connection error.', 'error' );
                return;
            }
        
        }
        
        //Webhook
        public function webhook()
        {
            require_once WCCASHAPP_PLUGIN_DIR . 'includes/functions/webhook.php';
        }
    
    }
} else {
    require_once WCCASHAPP_PLUGIN_DIR . 'includes/notifications/notices.php';
    deactivate_plugins( WCCASHAPP_PLUGIN_BASENAME );
}
