<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
global  $woocommerce, $total, $amount ;
$woocommerce->cart->get_cart();
$total = $woocommerce->cart->get_total();
$amount = $woocommerce->cart->total;
echo  '<fieldset id="wc-' . esc_attr( $this->id ) . '-form" style="padding:3%">' ;
// Add this action hook if you want your custom payment gateway to support it
do_action( 'woocommerce_form_start', $this->id );
echo 
    '<p>' . esc_html__( 'Send', 'wc-cashapp' ) . ' <a style="color:green" href="https://cash.app/',
    esc_attr( wp_kses_post( $this->ReceiverCashApp ) ),
    '/',
    esc_attr( wp_kses_post( $amount ) ),
    '" target="_blank">',
    $total . " " . esc_html__( 'to', 'wc-cashapp' ) . " " . esc_attr( wp_kses_post( $this->ReceiverCashApp ) ),
    '</a> ' . esc_html__( 'or click/scan the Cash App button below', 'wc-cashapp' ) . '</p>'
;
echo  '<p>' . wp_kses_post( __( 'Please <strong>use your Order Number (available once you place order)</strong> as the payment reference', 'wc-cashapp' ) ) . '.</p>' ;
echo  '<p class="wc-cashapp">' . esc_html__( 'Click', 'wc-cashapp' ) . ' > ' ;
echo 
    '<a href="https://cash.app/',
    esc_attr( wp_kses_post( $this->ReceiverCashApp ) ),
    '/',
    esc_attr( wp_kses_post( $amount ) ),
    '" target="_blank"><img width="150" height="150" class="logo-qr" alt="Square Cash app link" src="',
    esc_attr( WCCASHAPP_PLUGIN_DIR_URL . 'assets/images/cashapp.png' ),
    '"></a>'
;
echo 
    ' ' . esc_html__( 'or Scan', 'wc-cashapp' ) . ' > <a href="https://cash.app/',
    esc_attr( wp_kses_post( $this->ReceiverCashApp ) ),
    '/',
    esc_attr( wp_kses_post( $amount ) ),
    '" target="_blank"><img width="150" height="150" class="logo-qr" alt="Square Cash app link" src="https://chart.googleapis.com/chart?cht=qr&chld=L|0&chs=100x100&chl=https://cash.app/',
    esc_attr( wp_kses_post( $this->ReceiverCashApp ) ),
    '/',
    esc_attr( wp_kses_post( $amount ) ),
    '"></a></p>'
;
echo  '<p>' . wp_kses_post( __( '<strong>After paying, please come back here and place the order</strong> below so we can start processing your order', 'wc-cashapp' ) ) . '.</p>' ;
//
$call = esc_html__( 'call', 'wc-cashapp' ) . ' <a href="tel:' . esc_html( wp_kses_post( $this->ReceiverCASHAPPNo ) ) . '" target="_blank">' . esc_html( wp_kses_post( $this->ReceiverCASHAPPNo ) ) . '</a>.';
$email = ' ' . esc_html__( 'You can also email', 'wc-cashapp' ) . ' <a href="mailto:' . esc_html( wp_kses_post( $this->ReceiverCASHAPPEmail ) ) . '" target="_blank">' . esc_html( wp_kses_post( $this->ReceiverCASHAPPEmail ) ) . '</a>';
echo 
    '<p>' . esc_html__( 'If you are having an issue', 'wc-cashapp' ) . ', ',
    wp_kses_post( ( $call ? $call : '' ) ),
    wp_kses_post( ( $email ? $email : '' ) ),
    '</p>'
;
// toggleTutorial
if ( 'yes' === $this->toggleTutorial ) {
    echo  '<p><a href="https://theafricanboss.com/cashappdemo" style="text-decoration: underline" target="_blank">' . esc_html__( 'See this 1min video demo explaining how this works', 'wc-cashapp' ) . '.</a></p>' ;
}
// toggleCredits
if ( 'yes' === $this->toggleCredits ) {
    echo  '<p><a href="https://theafricanboss.com/cashapp" style="text-decoration: underline;" target="_blank">' . sprintf( esc_html__( 'Powered by %s', 'wc-cashapp' ), 'The African Boss' ) . '</a></p>' ;
}
do_action( 'woocommerce_form_end', $this->id );
echo  '<div class="clear"></div></fieldset>' ;