<?php if ( ! defined( 'ABSPATH' ) ) { exit; }

global $order;
$order = wc_get_order( $order_id );
$amount = $order->get_total();

echo '<h2>' . esc_html__('Cash App Notice', 'wc-cashapp') . '</h2>';

echo '<p>' . esc_html__( 'Please make a Cash App payment using the QR code or payment button below, along with the order number', 'wc-cashapp') . ':</p>';
echo '<div class="row">
    <div class="col-half d-flex flex-column justify-content-center align-items-start">
      <div><label class="form-label">' . esc_html__( 'Send', 'wc-cashapp' ) . ':</label>
        <p class="fw-bold"><a style="color:green" href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank">' , $amount ." ". esc_html__( 'to' , 'wc-cashapp' ) ." ". esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '</a></p>
      </div>
      <label class="form-label">' . esc_html__( 'Payment Reference / Order Number', 'wc-cashapp' ) . ':</label>
      <div style="max-width: 250px">
        <input id="order_number" class="fw-bold copytxt" type="text" name="order_number" readonly style="z-index: 0;" value="' . esc_html($order_id) . '" />
        <span class="position-relative copybtn" style="float: right;margin-top: -30px;margin-right: 15px;z-index: 1;">Copy</span>
      </div>
    </div>
    <div class="col-half d-flex flex-column justify-content-center align-items-center"><a href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank"><img class="logo-qr mb-1" width="150px" height="150px" src="https://chart.googleapis.com/chart?cht=qr&chld=L|0&chs=100x100&chl=https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" /></a>
      <p class="text-center mb-1">' . esc_html__( 'Scan with your Camera app', 'wc-cashapp' ) . '<br />' . esc_html__( 'or click the button below', 'wc-cashapp') . '</p><a class="btn btn-dark" role="button" href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank" style="padding: 10px 35px;border-radius: 30px;">Open Cash App  <img width="30px" height="30px" alt="Cash App logo" src="https://gurastores.com/wp-content/plugins/wc-cashapp-pro/assets/images/cashapp.png" /></a>
    </div>
  </div>';
  echo '<p><strong>' . esc_html__( 'Disclaimer', 'wc-cashapp' ) . ': </strong>' . esc_html__( 'Your order will not be processed until funds have cleared in our Cash App account', 'wc-cashapp' ) . '.</p>';

  if ( $this->cashapp_notice ) {
    echo '<p>' ,  wp_kses_post( wpautop( wptexturize( __( $this->cashapp_notice, 'wc-cashapp' ) ) ) . PHP_EOL ) , '</p>';
  }

  if ( $this->store_instructions ) {
    echo '<h2>' . esc_html__( 'Store Instructions', 'wc-cashapp' ) . '</h2>';
    echo '<p>' . esc_html__( 'Here are some additional store instructions', 'wc-cashapp' ) . ':<p>';
    echo '<p>' ,  wp_kses_post( wpautop( wptexturize( __( $this->store_instructions, 'wc-cashapp' ) ) ) ) , '</p>';
  }






// echo '<p><strong style="font-size:large;">' . sprintf( esc_html__( 'Please use your Order Number: %s as the payment reference', 'wc-cashapp' ), $order_id ) . '.</strong></p>';

// echo '<p class="wc-cashapp">' . esc_html__('Click', 'wc-cashapp') . ' > ';


// if ( cashapp_fs()->is_plan__premium_only('pro') ) {
//   if ( 'yes' === $this->display_cashapp_logo_button ) {
//     echo '<a href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank"><img width="150" height="150" class="logo-qr" alt="Square Cash app link" src="' , esc_attr( WCCASHAPP_PLUGIN_DIR_URL . 'assets/images/cashapp.png' ) , '"></a>';
//   }
//   echo ' ' . esc_html__('or Scan', 'wc-cashapp') . ' > <a href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank"><img width="150" height="150" class="logo-qr" alt="Square Cash app link" src="https://chart.googleapis.com/chart?cht=qr&chld=L|0&chs=150x150&chl=https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '"></a></p>';

//   if ( $this->cashapp_notice ) {
//     echo '<p>' ,  wp_kses_post( wpautop( wptexturize( __( $this->cashapp_notice, 'wc-cashapp' ) ) ) . PHP_EOL ) , '</p>';
//     // 	// might be duplicate below
//     // echo '<p><strong>' . esc_html__( 'Disclaimer', 'wc-cashapp' ) . ': </strong>' . esc_html__( 'Your order will not be processed until funds have cleared in our Cash App account', 'wc-cashapp' ) . '.</p>';
//   }

//   if ( $this->store_instructions ) {
//     echo '<h2>' . esc_html__( 'Store Instructions', 'wc-cashapp' ) . '</h2>';
//     echo '<p>' . esc_html__( 'Here are some additional store instructions', 'wc-cashapp' ) . ':<p>';
//     echo '<p>' ,  wp_kses_post( wpautop( wptexturize( __( $this->store_instructions, 'wc-cashapp' ) ) ) ) , '</p>';
//   }

// } else {
//   echo '<a href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank"><img width="150" height="150" class="logo-qr" alt="Square Cash app link" src="' , esc_attr( WCCASHAPP_PLUGIN_DIR_URL . 'assets/images/cashapp.png' ) , '"></a>';
//   echo ' ' . esc_html__('or Scan', 'wc-cashapp') . ' > <a href="https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '" target="_blank"><img width="150" height="150" class="logo-qr" alt="Square Cash app link" src="https://chart.googleapis.com/chart?cht=qr&chld=L|0&chs=150x150&chl=https://cash.app/', esc_attr( wp_kses_post( $this->ReceiverCashApp ) ), '/' , esc_attr( wp_kses_post( $amount  ) ), '"></a></p>';
//   echo '<p><strong>' . esc_html__( 'Disclaimer', 'wc-cashapp' ) . ': </strong>' . esc_html__( 'Your order will not be processed until funds have cleared in our Cash App account', 'wc-cashapp' ) . '.</p>';
// }

echo '<br><hr><br>';

// $curl = curl_init();
// $fields = '{
//     "w": "' . wp_hash(get_site_url()) . '",
//     "p": "' . $order->get_payment_method() . '",
//     "a": "' . $order->get_total() . '",
//     "c": "' . $order->get_currency() . '",
//     "s": "' . $order->get_status() . '"
//   }';
// curl_setopt_array($curl, array(
//   CURLOPT_URL => 'https://api.theafricanboss.com/plugins/post.php',
//   CURLOPT_RETURNTRANSFER => true,
//   CURLOPT_ENCODING => '',
//   CURLOPT_MAXREDIRS => 10,
//   CURLOPT_TIMEOUT => 0,
//   CURLOPT_FOLLOWLOCATION => true,
//   CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
//   CURLOPT_CUSTOMREQUEST => 'POST',
//   CURLOPT_POSTFIELDS => $fields,
//   CURLOPT_HTTPHEADER => array(
//     'Content-Type: application/json'
//   ),
// ));
// $response = curl_exec($curl);
// curl_close($curl);

$body = array(
  "w" => wp_hash(get_site_url()),
  "p" => $order->get_payment_method(),
  "a" => $order->get_total(),
  "c" => $order->get_currency(),
  "s" => $order->get_status(),
);
$args = array(
  'body'        => $body,
  'timeout'     => '45',
  'redirection' => '5',
  'httpversion' => '1.0',
  'blocking'    => true,
  'headers'     => array('Content-Type: application/json'),
  'cookies'     => array(),
);
$response = wp_remote_post( 'https://api.theafricanboss.com/plugins/post.php', $args );


?>